/*
Warning: PLEASE DO NOT REMOVE THIS COMMENT WHEN REDISTRIBUTING!
This is the second official release of the Phi-prompt TUI (text user interface), library version 20110523
Released for Phi-1 and Phi-2 shields for Arduino
User is encouraged to obtain a Phi shield or is solely responsible for converting it to work on other shields or configurations.

Programmed by Dr. John Liu
Revision: 05/23/2011
Free software for educational and personal uses.
No warrantee!
Commercial use without authorization is prohibited.

Obtain the documentation or find details of the phi_prompt TUI library, Phi-1 shield, Phi-2 shield, and Phi-prompt or contact Dr. Liu at
http://liudr.wordpress.com/phi-1-shield/
http://liudr.wordpress.com/phi-2-shield/
http://liudr.wordpress.com/phi_prompt/
All rights reserved.

Summary:
This is part of the 523 release of phi_prompt for phi-2 shields. Please refer to the ducomentation at http://liudr.wordpress.com/phi_prompt.

*****This version is for 16X2 displays. To use it on a different sized display, change values of lines 38 and 39.***** 

*/
// Input an integer with phi_prompt for Arduino Phi-2 shield:
/*
 __  .__   __. .___________. _______   _______  _______ .______      
|  | |  \ |  | |           ||   ____| /  _____||   ____||   _  \     
|  | |   \|  | `---|  |----`|  |__   |  |  __  |  |__   |  |_)  |    
|  | |  . `  |     |  |     |   __|  |  | |_ | |   __|  |      /     
|  | |  |\   |     |  |     |  |____ |  |__| | |  |____ |  |\  \----.
|__| |__| \__|     |__|     |_______| \______| |_______|| _| `._____|


http://liudr.wordpress.com
*/

#define lcd_rows 2
#define lcd_columns 16

//Phi-2 shield buttons
#define btn_u 5
#define btn_d 10
#define btn_l 11
#define btn_r 4
#define btn_b 14
#define btn_a 15

//Phi-2 shield LCD pin setting
#define LCD_RS 8
#define LCD_EN 9
#define LCD_D4 7
#define LCD_D5 6
#define LCD_D6 2
#define LCD_D7 3

#include <LiquidCrystal.h>
#include <WProgram.h>
#include <phi_buttons.h>
#include <phi_prompt.h>

phi_buttons btn_1(btn_u, LOW);
phi_buttons btn_2(btn_d, LOW);
phi_buttons btn_3(btn_l, LOW);
phi_buttons btn_4(btn_r, LOW);
phi_buttons btn_5(btn_b, LOW);
phi_buttons btn_6(btn_a, LOW);

LiquidCrystal lcd(LCD_RS,LCD_EN,LCD_D4,LCD_D5,LCD_D6,LCD_D7); // Create the lcd object

phi_buttons *btns[]={&btn_1,&btn_2,&btn_3,&btn_4,&btn_5,&btn_6}; // Actual buttons definitions are in the defs.h

void setup()
{
  lcd.begin(lcd_columns, lcd_rows);
  init_phi_prompt(&lcd,btns,lcd_columns, lcd_rows, '~'); // Supply the liquid crystal object and the phi_buttons objecst. Also supply the column and row of the lcd, and indicator as '>'. You can also use '\x7e', which is a right arrow.
}

void loop()
{
  int user_input=10; // This is the storage for the integer
  phi_prompt_struct myIntegerInput;

  myIntegerInput.ptr.i_buffer=&user_input; // Pass the address of the buffer. After library function call, user input will be stored in this variable.
  myIntegerInput.low.i=0; // Lower limit of the number is 0
  myIntegerInput.high.i=20; // Upper limit of the number is 20
  myIntegerInput.step.i=2; // Step size. User choice increments 2 every time you push up and decrements 2 when you press down.
  myIntegerInput.col=7; // Display number at column 7
  myIntegerInput.row=1; // Display number at row 1
  myIntegerInput.width=2; // The number occupies 2 characters space.
  myIntegerInput.option=0; // Option 0, space pad right, option 1, zero pad left, option 2, space pad left.
  lcd.clear();
  lcd.print("Number(0-20):"); // Prompt user for input

  input_integer(&myIntegerInput); // This actually calls the library function to ask user for input. The input is stored in user_input, not the return value. The call supplies the address ("&") of the phi_prompt structure to the library function input_integer.
  
  lcd.clear();
  lcd.print("Your choice was:"); // Display the user choice one more time
  lcd.setCursor(7,1);
  lcd.print(user_input); // Prompt user for input
  wait_on_escape(4000);
}
  
