/*
Warning: PLEASE DO NOT REMOVE THIS COMMENT WHEN REDISTRIBUTING!
This is the second official release of the Phi-prompt TUI (text user interface), library version 20110523
Released for Phi-1 and Phi-2 shields for Arduino
User is encouraged to obtain a Phi shield or is solely responsible for converting it to work on other shields or configurations.

Programmed by Dr. John Liu
Revision: 05/23/2011
Free software for educational and personal uses.
No warrantee!
Commercial use without authorization is prohibited.

Obtain the documentation or find details of the phi_prompt TUI library, Phi-1 shield, Phi-2 shield, and Phi-prompt or contact Dr. Liu at
http://liudr.wordpress.com/phi-1-shield/
http://liudr.wordpress.com/phi-2-shield/
http://liudr.wordpress.com/phi_prompt/
All rights reserved.

Summary:
This is part of the 523 release of phi_prompt for phi-2 shields. Please refer to the ducomentation at http://liudr.wordpress.com/phi_prompt.

*****This version is for 16X2 displays. To use it on a different sized display, change values of lines 38 and 39.***** 

*/

// Select an item from a list with phi_prompt for Arduino Phi-2 shield:
/*
 __       __       _______.___________.
|  |     |  |     /       |           |
|  |     |  |    |   (----`---|  |----`
|  |     |  |     \   \       |  |     
|  `----.|  | .----)   |      |  |     
|_______||__| |_______/       |__|     

http://liudr.wordpress.com
*/

#define lcd_rows 2
#define lcd_columns 16

//Phi-2 shield buttons
#define btn_u 5
#define btn_d 10
#define btn_l 11
#define btn_r 4
#define btn_b 14
#define btn_a 15

//Phi-2 shield LCD pin setting
#define LCD_RS 8
#define LCD_EN 9
#define LCD_D4 7
#define LCD_D5 6
#define LCD_D6 2
#define LCD_D7 3

#include <LiquidCrystal.h>
#include <WProgram.h>
#include <phi_buttons.h>
#include <phi_prompt.h>

// Test for sample list
PROGMEM prog_char pasta_00[]="Spaghetti";
PROGMEM prog_char pasta_01[]="Rotelle";
PROGMEM prog_char pasta_02[]="Rotini";
PROGMEM prog_char pasta_03[]="Fettuccine";
PROGMEM prog_char pasta_04[]="Lasagne";
PROGMEM prog_char pasta_05[]="Penne";
PROGMEM prog_char pasta_06[]="Rigatoni";
PROGMEM const char *pasta_items[]= {pasta_00,pasta_01,pasta_02,pasta_03,pasta_04,pasta_05,pasta_06};

phi_buttons btn_1(btn_u, LOW);
phi_buttons btn_2(btn_d, LOW);
phi_buttons btn_3(btn_l, LOW);
phi_buttons btn_4(btn_r, LOW);
phi_buttons btn_5(btn_b, LOW);
phi_buttons btn_6(btn_a, LOW);

LiquidCrystal lcd(LCD_RS,LCD_EN,LCD_D4,LCD_D5,LCD_D6,LCD_D7); // Create the lcd object

phi_buttons *btns[]={&btn_1,&btn_2,&btn_3,&btn_4,&btn_5,&btn_6}; // Actual buttons definitions are in the defs.h

void setup()
{
  lcd.begin(lcd_columns, lcd_rows);
  init_phi_prompt(&lcd,btns,lcd_columns, lcd_rows, '~'); // Supply the liquid crystal object and the phi_buttons objecst. Also supply the column and row of the lcd, and indicator as '>'. You can also use '\x7e', which is a right arrow.
}

void loop()
{
  int user_choice=0; // This will store the item the user chooses. Item number starts from zero.
  phi_prompt_struct myListInput; // This is the structure you will use to invoke library function select_list.

  myListInput.ptr.list=(char**)&pasta_items; // Assign the address of the list array to the pointer.
  myListInput.low.i=0; // Default item highlighted on the list is #0, the first item on the list.
  myListInput.high.i=6; // Last item on the list is size of the list - 1.
  myListInput.width=7; // Length in characters of the longest list item, for screen update purpose.
  myListInput.step.c_arr[0]=1;//rows 
  myListInput.step.c_arr[1]=2;//cols 
  myListInput.step.c_arr[2]=0;//y2 
  myListInput.step.c_arr[3]=12;//x2 
  myListInput.col=0; // Display the list at column 0
  myListInput.row=1; // Display the list at row 1
  myListInput.option=13;
  lcd.clear(); // Clear the lcd.
  lcd.print("Pasta list:"); // prompt the user.

  if (select_list(&myListInput)!=-1) // select_list stores user choice in myListInput.low.
  {  
    user_choice=myListInput.low.i; //If the user didn't press escape (return -1) then update the user choice with the value in myListInput.low.
    lcd.clear();
    lcd.print("Your choice was:"); // Display the user choice one more time
    lcd.setCursor(2,1); // Display the list at column 2 row 1.
    msg_lcd((char*)pgm_read_word(pasta_items+myListInput.low.i)); // Recall the message stored in PROGMEM and render in on LCD
  }
  else 
  {
    lcd.clear();
    lcd.print("You pressed ESC");
  }
  wait_on_escape(4000);
}
  
